{---------------------------------------------------------}
{                                                         }
{    Programa Palavrox                                    }
{                                                         }
{    Mdulo de variveis                                  }
{                                                         }
{    Autor: Joo Marcelo de Andrade & Joo Pedro Souza    }
{                                                         }
{    Em Outubro/2018                                      }
{                                                         }
{    Reviso: Jlio Silveira e Antonio Borges             }
{                                                         }
{    Em Dezembro/2018                                     }
{                                                         }
{---------------------------------------------------------}

unit pvvars;

interface

uses
    windows,
    SysUtils;

{-------------------------------------------------------------}
{                     tipos globais                           }
{-------------------------------------------------------------}

type
    TScore = record
        nome: String;
        pontos: integer;
    end;

    TTempoDeJogo = record
        hor, min, seg, ms:  word;
    end;

{-------------------------------------------------------------}
{                      variveis globais                      }
{-------------------------------------------------------------}

const
    _Desconhecida = 0;
    _Inexistente  = 1;
    _Valida      = 2;
    _Repetida     = 3;
    _Pequena      = 4;

const
    versao = '1.1a';

    duracaoMaxJogada: TTempoDeJogo = (hor: 0; min: 2; seg: 0; ms: 0 );

var
    nivel : integer;               { nvel de dificuldade escolhida }

    tempoLimDaJogada: TDateTime;   { Converso de duracao mxima para TDateTime }
    inicioDaJogada: TDateTime;     { TDateTime do incio da palavra atual }
    tempoDaJogada:  TDateTime;     { Tempo de durao da palavra atual }
    tempoEsgotado:   boolean;      { tempoDaJogada > tempoLimDaJogada }

    quantasAchadas : integer;
    listaDeAchadas : array of shortstring;

    palavraSorteada: string;       { palavra escolhida como raiz de cada partida }
    letrasDisponiveis: string;     { letras que pode usar a cada momento }
    tentativa        : string;     { recebe a palavra durante a digitao }

    nomeArqScores:  string;
    scores : array [1..10] of TScore;
    nScores: integer;
    marcacao: integer;
    pontuacaoTotal: integer;
    pontuacaoExtra: integer;

    winRect:  TRect;
    ambiente: string;

implementation

end.

